Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser	(revision 319)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser	(revision 320)
@@ -4476,44 +2814,4 @@
 			sepNavVisRect = "{{0, 347}, {585, 566}}";
 		};
-	};
-	E1FC8DC00C1A2DC70021AB09 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = E14343B303DB4CF200050002 /* ICeCoffEE.h */;
-		name = "ICeCoffEE.h: 10";
-		rLen = 0;
-		rLoc = 486;
-		rType = 0;
-		vrLen = 2268;
-		vrLoc = 0;
-	};
-	E1FC8DC10C1A2DC70021AB09 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = E14343B403DB4CF200050002 /* ICeCoffEE.m */;
-		name = "IconRef ICCF_CopyIconRefForPath(NSString *path) {";
-		rLen = 0;
-		rLoc = 17466;
-		rType = 0;
-		vrLen = 2958;
-		vrLoc = 16794;
-	};
-	E1FC8DC20C1A2DC70021AB09 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = E14343B403DB4CF200050002 /* ICeCoffEE.m */;
-		name = "IconRef ICCF_CopyIconRefForPath(NSString *path) {";
-		rLen = 0;
-		rLoc = 17466;
-		rType = 0;
-		vrLen = 2958;
-		vrLoc = 16794;
-	};
-	E1FC8DC30C1A2DC70021AB09 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = E14343B303DB4CF200050002 /* ICeCoffEE.h */;
-		name = "ICeCoffEE.h: 10";
-		rLen = 0;
-		rLoc = 486;
-		rType = 0;
-		vrLen = 2268;
-		vrLoc = 0;
 	};
 	E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */ = {
@@ -4532,14 +2830,4 @@
 		};
 	};
-	E1FC90EC0C1A56690021AB09 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = E14343B403DB4CF200050002 /* ICeCoffEE.m */;
-		name = "ICeCoffEE.m: UNICHAR_BLACK_RIGHT_POINTING_SMALL_TRIANGLE";
-		rLen = 0;
-		rLoc = 17466;
-		rType = 0;
-		vrLen = 3065;
-		vrLoc = 16794;
-	};
 	F56276BA03796C8B01AA4DA5 /* CFPreferencesWrapper.m */ = {
 		uiCtxt = {
@@ -4553,6 +2841,6 @@
 		uiCtxt = {
 			sepNavIntBoundsRect = "{{0, 0}, {715, 6362}}";
-			sepNavSelRange = "{7662, 0}";
-			sepNavVisRect = "{{0, 2468}, {715, 708}}";
+			sepNavSelRange = "{265, 0}";
+			sepNavVisRect = "{{0, 0}, {715, 708}}";
 			sepNavWindowFrame = "{{856, 25}, {754, 746}}";
 		};
@@ -4568,7 +2856,7 @@
 	F9A6986E03BE1DF000AA4DA5 /* APEMain.m */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {813, 3470}}";
-			sepNavSelRange = "{13167, 26}";
-			sepNavVisRect = "{{0, 3174}, {813, 296}}";
+			sepNavIntBoundsRect = "{{0, 0}, {713, 3624}}";
+			sepNavSelRange = "{4556, 21}";
+			sepNavVisRect = "{{0, 1422}, {713, 616}}";
 			sepNavWindowFrame = "{{69, -4}, {752, 654}}";
 		};
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 319)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 320)
@@ -8,5 +8,5 @@
 
 #import "ICeCoffEEShared.h"
-#import "ICeCoffEESetServicesMenu.h"
+#import "ICeCoffEEServices.h"
 #import "ICeCoffEEServicePrefController.h"
 #import "ICeCoffEENonHighlightingButtonCell.h"
@@ -183,5 +183,5 @@
 	
 	if ( (submenu = [menuItem submenu]) != nil) {
-	    ICCF_AddServiceKeyEquivalentsAndIcons(submenu, itemInfo);
+	    ICCF_AddServiceKeyEquivalentsAndIcons(submenu, [itemInfo objectForKey: (NSString *)kICServiceSubmenu]);
 	} else {
 	    NSString *keyEquivalent = (NSString *)[itemInfo objectForKey: (NSString *)kICServiceShortcut];
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServices.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServices.h	(revision 320)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServices.h	(revision 320)
@@ -0,0 +1,20 @@
+//
+//  ICeCoffEEServices.h
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on 5/10/05.
+//  Copyright 2005 Nicholas Riley. All rights reserved.
+//
+
+#import <Cocoa/Cocoa.h>
+
+NSDictionary *ICCF_GetServicesInfo(void);
+void ICCF_SetServicesMenu(NSMenu *servicesMenu);
+
+IconRef ICCF_CopyIconRefForPath(NSString *path);
+
+// Cocoa additions
+@interface NSMenuItem (IC_IconRef)
+- (IconRef)_iconRef;
+- (void)_setIconRef:(IconRef)iconRef;
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServices.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServices.m	(revision 320)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServices.m	(revision 320)
@@ -0,0 +1,160 @@
+//
+//  ICeCoffEEServices.m
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on 5/10/05.
+//  Copyright 2005 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEEServices.h"
+#import "ICeCoffEEShared.h"
+
+// an approximate clone of HIToolbox's CreateServicesLocalizedDictKey
+static CFStringRef preferredLocalization(CFDictionaryRef localizations) {
+    if (localizations == NULL)
+	return NULL;
+    
+    CFIndex localizationCount = CFDictionaryGetCount(localizations);
+    if (localizationCount == 0)
+	return NULL;
+    
+    const void **locales = malloc(localizationCount * sizeof(void *));
+    if (locales == NULL)
+	return NULL;
+    
+    CFDictionaryGetKeysAndValues(localizations, locales, NULL);
+    CFArrayRef availableLocales = CFArrayCreate(NULL, locales, localizationCount, NULL);
+    if (availableLocales == NULL)
+	return NULL;
+    
+    // XXX does this actually work in a localized app?
+    CFArrayRef preferredLocales = CFBundleCopyPreferredLocalizationsFromArray(availableLocales);
+    // NSLog(@"%@ => %@", availableLocales, preferredLocales);
+    CFRelease(availableLocales);
+    CFStringRef preferredLocalization;
+    if (preferredLocales != NULL) {
+	if (CFArrayGetCount(preferredLocales) > 0) {
+	    CFStringRef preferredLocale = CFArrayGetValueAtIndex(preferredLocales, 0);
+	    preferredLocalization = (CFStringRef)CFDictionaryGetValue(localizations, preferredLocale);
+	}
+	CFRelease(preferredLocales);
+    }
+    if (preferredLocalization == NULL) {
+	preferredLocalization = (CFStringRef)CFDictionaryGetValue(localizations, CFSTR("default"));
+	if (preferredLocalization == NULL)
+	    preferredLocalization = (CFStringRef)CFDictionaryGetValue(localizations, (CFStringRef)locales[0]);
+    }
+    
+    free(locales);
+    // NSLog(@"%@", preferredLocalization);
+    return preferredLocalization;
+}
+
+NSArray *CFServiceControllerCopyServicesEntries(void);
+
+NSDictionary *ICCF_GetServicesInfo(void) {
+    NSArray *services = CFServiceControllerCopyServicesEntries();
+    
+    NSEnumerator *e = [services objectEnumerator];
+    NSDictionary *serviceEntry;
+    NSMutableDictionary *serviceDict = [[NSMutableDictionary alloc] init];
+    while ( (serviceEntry = (NSDictionary *)[e nextObject]) != nil) {
+	// XXX once tested, redo all this with CF, and no autoreleasing
+	// XXX items named the same as submenus (figure out how Cocoa itself does it, too)
+	NSString *itemPath = (NSString *)preferredLocalization((CFDictionaryRef)[serviceEntry objectForKey: @"NSMenuItem"]);
+	if (itemPath == nil) continue;
+	
+	NSString *bundlePath = [serviceEntry objectForKey: @"NSBundlePath"];
+	BOOL bubbledUp = (bundlePath == nil);
+	NSArray *itemComponents = [itemPath componentsSeparatedByString: @"/"];
+	NSEnumerator *ce = [itemComponents objectEnumerator];
+	NSString *itemComponent;
+	NSMutableDictionary *levelDict = serviceDict;
+	NSMutableDictionary *itemDict = nil;
+	while ( (itemComponent = (NSString *)[ce nextObject]) != nil) {
+	    // levelDict is nil if just created
+	    if (levelDict != nil && !bubbledUp) {
+		NSString *oldBundlePath = [itemDict objectForKey: (NSString *)kICServiceBundlePath];
+		if ([oldBundlePath isEqualToString: bundlePath])
+		    bubbledUp = YES;
+		else if (oldBundlePath != nil) {
+		    [oldBundlePath retain];
+		    [itemDict removeObjectForKey: (NSString *)kICServiceBundlePath];
+		    NSEnumerator *be = [levelDict objectEnumerator];
+		    while ( (itemDict = (NSMutableDictionary *)[be nextObject]) != nil)
+			[itemDict setObject: oldBundlePath forKey: (NSString *)kICServiceBundlePath];
+		    [oldBundlePath release];
+		}
+	    }
+	    if (levelDict == nil) {
+		levelDict = [[NSMutableDictionary alloc] init];
+		[itemDict setObject: levelDict forKey: (NSString *)kICServiceSubmenu];
+		[levelDict release];
+		itemDict = nil;
+	    } else {
+		itemDict = [levelDict objectForKey: itemComponent];
+	    }
+	    if (itemDict == nil) {
+		itemDict = [[NSMutableDictionary alloc] init];
+		if (!bubbledUp) {
+		    [itemDict setObject: bundlePath forKey: (NSString *)kICServiceBundlePath];
+		    bubbledUp = YES;
+		}
+		[levelDict setObject: itemDict forKey: itemComponent];
+		levelDict = nil;
+		[itemDict release];
+	    } else {
+		levelDict = [itemDict objectForKey: (NSString *)kICServiceSubmenu];
+	    }
+	}
+	
+	if (!bubbledUp)
+	    [itemDict setObject: bundlePath forKey: (NSString *)kICServiceBundlePath];
+
+	NSString *keyEquivalent = (NSString *)preferredLocalization((CFDictionaryRef)[serviceEntry objectForKey: @"NSKeyEquivalent"]);
+	if (keyEquivalent == nil) continue;
+
+	[itemDict setObject: keyEquivalent forKey: (NSString *)kICServiceShortcut];
+    }
+    [services release];
+    
+    return [serviceDict autorelease];
+}
+
+
+void ICCF_SetServicesMenu(NSMenu *servicesMenu) {
+    // in 10.3, this populates the menu; in 10.4, it attaches a delegate (NSServiceMaster)
+    [[NSApplication sharedApplication] setServicesMenu: servicesMenu];
+    id delegate;
+    if ( (delegate = [servicesMenu delegate]) != nil) {
+	// populate menu so we have something to filter
+	if ([delegate respondsToSelector: @selector(menuNeedsUpdate:)]) {
+	    [delegate menuNeedsUpdate: servicesMenu];
+	}
+	if ([delegate respondsToSelector: @selector(menu:updateItem:atIndex:shouldCancel:)]) {
+	    int itemCount = [delegate numberOfItemsInMenu: servicesMenu];
+	    for (int i = 0 ; i < itemCount ; i++) {
+		[servicesMenu addItemWithTitle: @"" action: NULL keyEquivalent: @""];
+	    }
+	    for (int i = 0 ; i < itemCount ; i++) {
+		if (![delegate menu: servicesMenu updateItem: (NSMenuItem *)[servicesMenu itemAtIndex: i] atIndex: i shouldCancel: NO])
+		    break;
+	    }
+	}
+    }
+}
+
+IconRef ICCF_CopyIconRefForPath(NSString *path) {
+    IconRef icon;
+    FSRef fsr;
+    SInt16 label;
+    OSStatus err = noErr;
+    
+    err = FSPathMakeRef((const UInt8 *)[path fileSystemRepresentation], &fsr, NULL);
+    if (err != noErr) return NULL;
+    
+    err = GetIconRefFromFileInfo(&fsr, 0, NULL, kFSCatInfoNone, NULL, kIconServicesNormalUsageFlag, &icon, &label);
+    if (err != noErr) return NULL;
+    
+    return icon;
+}
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETerminal.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETerminal.m	(revision 319)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETerminal.m	(revision 320)
@@ -326,5 +326,6 @@
             NSCAssert(delimiterRange.length == 1, @"Internal error: delimiter matched range is not of length 1");
             [selRange growBackwardByLength: [s length] - delimiterRange.location - 1];
-	    // in https://www-s.acm.uiuc.edu/wiki/space/(user)njriley - handle clicking inside or after (user).
+	    
+	    // in url/(parens)stuff, handle clicking inside or after (parens).
 	    if ([s characterAtIndex: delimiterRange.location] == '(') {
 		s = [selRange stringFromRange];
@@ -332,5 +333,5 @@
 		    [s rangeOfCharacterFromSet: [NSCharacterSet characterSetWithCharactersInString: @"/."]].location == NSNotFound) {
 		    [selRange growBackwardByLength: 1];
-		    ICLog(@"expanding past (, now %@", selRange);
+		    ICLog(@"expanding past (, now |%@|", selRange);
 		    [termRange shrinkBackByLength: [[termRange stringFromRange] length] - delimiterRange.location];
 		    goto expandFront;
@@ -355,9 +356,10 @@
             NSCAssert(delimiterRange.length == 1, @"Internal error: delimiter matched range is not of length 1");
             [selRange growForwardByLength: delimiterRange.location];
-	    // URL may look like "https://www-s.acm.uiuc.edu/wiki/space/(user" now; expand if so
+	    
+	    // grow URL past closing paren if we've seen an open paren
 	    if ([s characterAtIndex: delimiterRange.location] == ')' &&
 		[[selRange stringFromRange] rangeOfString: @"("].location != NSNotFound) {
 		[selRange growForwardByLength: 1];
-		ICLog(@"expanding past ), now %@", selRange);
+		ICLog(@"expanding past ), now |%@|", selRange);
 		[termRange shrinkFrontByLength: delimiterRange.location + 1];
 		goto expandBack;
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEWebKit.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEWebKit.m	(revision 319)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEWebKit.m	(revision 320)
@@ -10,21 +10,24 @@
 #import <unistd.h>
 
-// from WebCoreBridge.h
+// WebCoreBridge, from WebCoreBridge.h (Safari 2)
+// Web(Core)FrameBridge, from WebCoreFrameBridge.h (Safari 3)
 @interface WebCoreBridge : NSObject
+
+// can only use setMarkedText:selectedRange: if WebHTMLView is editable
+// or, should we move to DOM-based accessors, i.e. "setMarkDOMRange"?
+- (void)selectNSRange:(NSRange)range;
+
+@end
+
+// from WebKit, private -- XXX maybe I'm better off going back the other way, relying on public methods in the bridge?
+@interface WebHTMLView : NSObject
 
 - (NSString *)selectedString;
 - (NSRect)selectionRect;
-
-- (void)selectNSRange:(NSRange)range;
+- (NSRect)_selectionRect; // Safari 2, supported in Safari 3 only for use with Mail
+- (NSRange)selectedRange; // XXX same as selectedNSRange in WebCoreFrameBridge.h?
 - (void)deselectAll;
 
-@end
-
-// from WebKit, private
-@interface WebHTMLView : NSObject
-
-- (WebCoreBridge *)_bridge;
-
-- (NSRange)selectedRange;
+- (WebCoreBridge *)_bridge; /* WebFrameBridge in Safari 3 (see above) */
 
 - (NSDictionary *)elementAtPoint:(NSPoint)point;
@@ -48,5 +51,4 @@
     [downEvent release]; downEvent = nil;
     if (ICCF_enabled && ICCF_prefs.commandClickEnabled && ICCF_EventIsCommandMouseDown(e)) {
-        WebCoreBridge *bridge = [(WebHTMLView *)self _bridge];
 	if ([self respondsToSelector: @selector(selectedRange)]) {
 	    // save selection: it may be deselected on super mouseDown
@@ -54,5 +56,5 @@
 	}
 	[selectedString release]; selectedString = nil;
-	selectedString = [[bridge selectedString] retain];
+	selectedString = [[(WebHTMLView *)self selectedString] retain];
         downEvent = [e retain];
     }
@@ -77,5 +79,5 @@
             if ([elementDict objectForKey: @"WebElementLinkURL"] != nil) {
                 ICLog(@"got a link");
-                NS_VOIDRETURN; // donÕt activate on links
+                NS_VOIDRETURN; // don't activate on links
             }
 	    if (selectedString == nil || [selectedString length] == 0) {
@@ -91,8 +93,12 @@
 	    if (ICCF_LaunchURL(selectedString, ICCF_KeyboardAction(downEvent)) && ICCF_prefs.textBlinkEnabled && canSetSelection) {
 		int i;
-		NSRect selectionRect = [bridge selectionRect];
+		NSRect selectionRect;
+		if ([self respondsToSelector: @selector(selectionRect)])
+		    selectionRect = [(WebHTMLView *)self selectionRect];
+		else
+		    selectionRect = [(WebHTMLView *)self _selectionRect];
 		ICLog(@"selectedRange %@ selectionRect %@ textBlinkCount %d", NSStringFromRange(selectedRange), NSStringFromRect(selectionRect), ICCF_prefs.textBlinkCount);
 		for (i = 0 ; i < ICCF_prefs.textBlinkCount ; i++) {
-		    [bridge deselectAll];
+		    [(WebHTMLView *)self deselectAll];
 		    [self setNeedsDisplayInRect: selectionRect];
 		    [self display];
